Index: src/java/org/jivesoftware/sparkimpl/preference/media/MediaPreferencePanel.java
===================================================================
--- src/java/org/jivesoftware/sparkimpl/preference/media/MediaPreferencePanel.java	(revision 0)
+++ src/java/org/jivesoftware/sparkimpl/preference/media/MediaPreferencePanel.java	(revision 0)
@@ -0,0 +1,118 @@
+package org.jivesoftware.sparkimpl.preference.media;
+
+import java.awt.GridBagConstraints;
+import java.awt.GridBagLayout;
+import java.awt.Insets;
+import java.util.Vector;
+
+import javax.media.CaptureDeviceInfo;
+import javax.media.CaptureDeviceManager;
+import javax.media.Format;
+import javax.media.format.AudioFormat;
+import javax.media.format.VideoFormat;
+import javax.swing.BorderFactory;
+import javax.swing.JComboBox;
+import javax.swing.JLabel;
+import javax.swing.JPanel;
+
+import net.sf.fmj.media.RegistryDefaults;
+import net.sf.fmj.media.cdp.GlobalCaptureDevicePlugger;
+
+import org.jivesoftware.resource.Res;
+import org.jivesoftware.spark.component.VerticalFlowLayout;
+
+public class MediaPreferencePanel  extends JPanel {
+	private static final long serialVersionUID = 8297469864676223072L;
+	private Vector<CaptureDeviceInfo> vectorAudioDevices;
+	private Vector<CaptureDeviceInfo> vectorVideoDevices;
+	
+	private JComboBox audioDevice = new JComboBox();
+	private JComboBox videoDevice = new JComboBox();
+	
+	public MediaPreferencePanel() {
+		setLayout(new VerticalFlowLayout());
+		
+		JPanel panel = new JPanel();
+		panel.setBorder(BorderFactory.createTitledBorder(Res.getString("title.general.media")));
+		add(panel);
+			
+		panel.setLayout(new GridBagLayout());
+		
+		
+		panel.add(new JLabel("Audio Device"), new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(10, 15, 5, 0), 0, 0));
+		panel.add(audioDevice, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(10, 15, 5, 0), 0, 0));
+		
+		
+		
+		panel.add(new JLabel("Video Device"), new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(10, 15, 5, 0), 0, 0));
+        panel.add(videoDevice, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(10, 15, 5, 0), 0, 0));
+	
+        scanDevices();
+	}
+	
+	public void scanDevices()
+	{
+		// Remove all Items
+		audioDevice.removeAllItems();
+		videoDevice.removeAllItems();
+		
+		// FMJ
+		RegistryDefaults.registerAll(RegistryDefaults.FMJ | RegistryDefaults.FMJ_NATIVE);
+
+		// Add Device
+		GlobalCaptureDevicePlugger.addCaptureDevices(); 
+		
+		// LOG ALL Devices
+		final Vector<CaptureDeviceInfo> vectorDevices = CaptureDeviceManager.getDeviceList(null);
+		for ( CaptureDeviceInfo infoCaptureDevice : vectorDevices )
+		{
+			System.err.println(infoCaptureDevice.getName());
+			for (Format format : infoCaptureDevice.getFormats())
+			{
+				System.err.println(format);
+			}		
+		}
+		
+		vectorAudioDevices = CaptureDeviceManager.getDeviceList(new AudioFormat(AudioFormat.LINEAR));	
+		for ( CaptureDeviceInfo infoCaptureDevice : vectorAudioDevices)
+		{			     
+			audioDevice.addItem(infoCaptureDevice.getName());
+		}
+		
+		vectorVideoDevices = CaptureDeviceManager.getDeviceList(new VideoFormat(VideoFormat.RGB));
+		for (  CaptureDeviceInfo infoCaptureDevice : vectorVideoDevices )
+		{
+            videoDevice.addItem(infoCaptureDevice.getName());		
+		}
+	}
+	
+	public String getAudioDevice() {
+		if (videoDevice.getSelectedIndex() >= 0) {
+			return vectorAudioDevices.get(audioDevice.getSelectedIndex()).getLocator().toExternalForm();
+		}
+		return "";
+	}
+	
+	public void setAudioDevice(String device) {
+		for ( CaptureDeviceInfo infoCaptureDevice : vectorAudioDevices) {
+			if (infoCaptureDevice.getLocator().toExternalForm().equals(device)) {
+				audioDevice.setSelectedItem(infoCaptureDevice.getName());
+			}
+		}	
+	}
+	
+	public void setVideoDevice(String device) {
+		for ( CaptureDeviceInfo infoCaptureDevice : vectorVideoDevices) {
+			if (infoCaptureDevice.getLocator().toExternalForm().equals(device)) {
+				videoDevice.setSelectedItem(infoCaptureDevice.getName());
+			}
+		}	
+	}
+	
+	public String getVideoDevice() {
+		if (videoDevice.getSelectedIndex() >= 0) {
+			return vectorVideoDevices.get(videoDevice.getSelectedIndex()).getLocator().toExternalForm();
+		}
+		return "";
+	}
+}
Index: src/plugins/sip/src/java/net/java/sipmack/softphone/SoftPhoneManager.java
===================================================================
--- src/plugins/sip/src/java/net/java/sipmack/softphone/SoftPhoneManager.java	(revision 11009)
+++ src/plugins/sip/src/java/net/java/sipmack/softphone/SoftPhoneManager.java	(working copy)
@@ -10,73 +10,20 @@
 
 package net.java.sipmack.softphone;
 
-import org.jivesoftware.sparkplugin.calllog.LogManager;
-import org.jivesoftware.sparkplugin.calllog.LogPacket;
-import org.jivesoftware.sparkplugin.preferences.SipPreference;
-import org.jivesoftware.sparkplugin.preferences.SipPreferences;
-import org.jivesoftware.sparkplugin.sipaccount.SipAccount;
-import org.jivesoftware.sparkplugin.sipaccount.SipAccountPacket;
-import org.jivesoftware.sparkplugin.ui.call.MissedCalls;
-import org.jivesoftware.spark.plugin.phone.resource.PhoneRes;
-import net.java.sipmack.common.DialSoundManager;
-import net.java.sipmack.common.Log;
-import net.java.sipmack.events.UserActionListener;
-import net.java.sipmack.media.AudioMediaSession;
-import net.java.sipmack.media.AudioReceiverChannel;
-import net.java.sipmack.media.JmfMediaManager;
-import net.java.sipmack.media.MediaException;
-import net.java.sipmack.sip.Call;
-import net.java.sipmack.sip.CommunicationsException;
-import net.java.sipmack.sip.Interlocutor;
-import net.java.sipmack.sip.InterlocutorUI;
-import net.java.sipmack.sip.NetworkAddressManager;
-import net.java.sipmack.sip.SIPConfig;
-import net.java.sipmack.sip.SipManager;
-import net.java.sipmack.sip.SipRegisterStatus;
-import net.java.sipmack.sip.event.CallEvent;
-import net.java.sipmack.sip.event.CallListener;
-import net.java.sipmack.sip.event.CallRejectedEvent;
-import net.java.sipmack.sip.event.CallStateEvent;
-import net.java.sipmack.sip.event.CommunicationsErrorEvent;
-import net.java.sipmack.sip.event.CommunicationsListener;
-import net.java.sipmack.sip.event.MessageEvent;
-import net.java.sipmack.sip.event.RegistrationEvent;
-import net.java.sipmack.sip.event.UnknownMessageEvent;
-import net.java.sipmack.softphone.gui.DefaultGuiManager;
-import net.java.sipmack.softphone.gui.GuiManager;
-import net.java.sipmack.softphone.listeners.InterlocutorListener;
-import net.java.sipmack.softphone.listeners.RegisterEvent;
-import net.java.sipmack.softphone.listeners.SoftPhoneListener;
-import org.jivesoftware.resource.Res;
-import org.jivesoftware.smack.XMPPConnection;
-import org.jivesoftware.smack.provider.ProviderManager;
-import org.jivesoftware.smack.util.StringUtils;
-import org.jivesoftware.smackx.packet.VCard;
-import org.jivesoftware.spark.SparkManager;
-import org.jivesoftware.spark.phone.PhoneManager;
-import org.jivesoftware.spark.preference.PreferenceManager;
-import org.jivesoftware.spark.util.ModelUtil;
-
-import javax.sdp.MediaDescription;
-import javax.sdp.SessionDescription;
-import javax.swing.JCheckBoxMenuItem;
-import javax.swing.JMenu;
-
 import java.awt.Component;
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
+import java.util.Vector;
 import java.util.concurrent.CopyOnWriteArrayList;
-import org.jivesoftware.sparkplugin.calllog.LogManager;
-import org.jivesoftware.sparkplugin.calllog.LogPacket;
-import org.jivesoftware.sparkplugin.preferences.SipPreference;
-import org.jivesoftware.sparkplugin.preferences.SipPreferences;
-import org.jivesoftware.sparkplugin.sipaccount.SipAccount;
-import org.jivesoftware.sparkplugin.sipaccount.SipAccountPacket;
-import org.jivesoftware.sparkplugin.ui.call.MissedCalls;
-import org.jivesoftware.spark.plugin.phone.resource.PhoneRes;
+
+import javax.sdp.MediaDescription;
+import javax.sdp.SessionDescription;
+import javax.swing.JCheckBoxMenuItem;
+import javax.swing.JMenu;
+
 import net.java.sipmack.common.DialSoundManager;
 import net.java.sipmack.common.Log;
 import net.java.sipmack.events.UserActionListener;
@@ -84,6 +31,7 @@
 import net.java.sipmack.media.AudioReceiverChannel;
 import net.java.sipmack.media.JmfMediaManager;
 import net.java.sipmack.media.MediaException;
+import net.java.sipmack.media.VideoMediaSession;
 import net.java.sipmack.sip.Call;
 import net.java.sipmack.sip.CommunicationsException;
 import net.java.sipmack.sip.Interlocutor;
@@ -106,6 +54,7 @@
 import net.java.sipmack.softphone.listeners.InterlocutorListener;
 import net.java.sipmack.softphone.listeners.RegisterEvent;
 import net.java.sipmack.softphone.listeners.SoftPhoneListener;
+
 import org.jivesoftware.resource.Res;
 import org.jivesoftware.smack.XMPPConnection;
 import org.jivesoftware.smack.provider.ProviderManager;
@@ -113,21 +62,17 @@
 import org.jivesoftware.smackx.packet.VCard;
 import org.jivesoftware.spark.SparkManager;
 import org.jivesoftware.spark.phone.PhoneManager;
+import org.jivesoftware.spark.plugin.phone.resource.PhoneRes;
 import org.jivesoftware.spark.preference.PreferenceManager;
 import org.jivesoftware.spark.util.ModelUtil;
-
-import javax.sdp.MediaDescription;
-import javax.sdp.SessionDescription;
-import javax.swing.JCheckBoxMenuItem;
-import javax.swing.JMenu;
-
-import java.awt.Component;
-import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
-import java.util.concurrent.CopyOnWriteArrayList;
+import org.jivesoftware.sparkimpl.settings.local.SettingsManager;
+import org.jivesoftware.sparkplugin.calllog.LogManager;
+import org.jivesoftware.sparkplugin.calllog.LogPacket;
+import org.jivesoftware.sparkplugin.preferences.SipPreference;
+import org.jivesoftware.sparkplugin.preferences.SipPreferences;
+import org.jivesoftware.sparkplugin.sipaccount.SipAccount;
+import org.jivesoftware.sparkplugin.sipaccount.SipAccountPacket;
+import org.jivesoftware.sparkplugin.ui.call.MissedCalls;
 
 /**
  * Title: SIPark
@@ -168,7 +113,7 @@
 
     protected String msgBuffer = "";
 
-    protected Integer unregistrationLock = new Integer(0);
+    protected Integer unregistrationLock = Integer.valueOf(0);
 
     private static SipRegisterStatus status = SipRegisterStatus.Unregistered;
 
@@ -513,8 +458,8 @@
      * @param evt CallRejectedEvent
      */
     public void callRejectedLocally(CallRejectedEvent evt) {
-        String reason = evt.getReason();
-        String detailedReason = evt.getDetailedReason();
+//        String reason = evt.getReason();
+//        String detailedReason = evt.getDetailedReason();
     }
 
     /**
@@ -687,18 +632,44 @@
                     PhoneManager.setUsingMediaLocator(false);
                 }
 
-                int localPort = ((MediaDescription) (call.getLocalSdpDescription().getMediaDescriptions(true).get(0))).getMedia().getMediaPort();
-
-                AudioMediaSession audioMediaSession = mediaManager.createAudioMediaSession(call.getRemoteSdpDescription().toString(), localPort);
+                int localAudioPort = -1;
+                int localVideoPort = -1;
+                
+               
+                Vector<MediaDescription> mediaDescriptions = call.getLocalSdpDescription().getMediaDescriptions(true);
+                for (MediaDescription mediaDescription : mediaDescriptions)
+                {
+                	if (mediaDescription.getMedia().getMediaType().equals("audio"))
+                		localAudioPort = mediaDescription.getMedia().getMediaPort();
+                	else if (mediaDescription.getMedia().getMediaType().equals("video"))
+                		localVideoPort = mediaDescription.getMedia().getMediaPort();
+                }
+                
+                AudioMediaSession audioMediaSession = mediaManager.createAudioMediaSession(call.getRemoteSdpDescription().toString(), localAudioPort);                
                 call.setAudioMediaSession(audioMediaSession);
 
                 if (audioMediaSession != null) {
                     audioMediaSession.startTrasmit();
                     audioMediaSession.startReceive();
                 }
+                
+                // If remote client have video
+                if (localVideoPort > 0)
+                {
+                	System.out.println("Port:" + localVideoPort);
+                	if (SettingsManager.getLocalPreferences().getVideoDevice() != null)
+                	{
+		                VideoMediaSession videoMediaSession = mediaManager.createVideoMediaSession(call.getRemoteSdpDescription().toString(), localVideoPort);
+		                if (videoMediaSession != null) {
+		                	videoMediaSession.startTrasmit();
+		                	videoMediaSession.startReceive();
+		                }
+                	}
+                }
 
+                
                 evt.getSourceCall().start();
-
+                
                 Log.debug("MEDIA STREAMS OPENED");
 
             } else if (evt.getNewState() == Call.RINGING) {
Index: src/plugins/sip/src/java/net/java/sipmack/sip/security/SipSecurityException.java
===================================================================
--- src/plugins/sip/src/java/net/java/sipmack/sip/security/SipSecurityException.java	(revision 11009)
+++ src/plugins/sip/src/java/net/java/sipmack/sip/security/SipSecurityException.java	(working copy)
@@ -1,61 +1,12 @@
-/* ====================================================================
- * The Apache Software License, Version 1.1
- *
- * Copyright (c) 2000 The Apache Software Foundation.  All rights
- * reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The end-user documentation included with the redistribution,
- *    if any, must include the following acknowledgment:
- *       "This product includes software developed by the
- *        Apache Software Foundation (http://www.apache.org/)."
- *    Alternately, this acknowledgment may appear in the software itself,
- *    if and wherever such third-party acknowledgments normally appear.
- *
- * 4. The names "Apache" and "Apache Software Foundation" must
- *    not be used to endorse or promote products derived from this
- *    software without prior written permission. For written
- *    permission, please contact apache@apache.org.
- *
- * 5. Products derived from this software may not be called "Apache",
- *    nor may "Apache" appear in their name, without prior written
- *    permission of the Apache Software Foundation.
- *
- * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
- * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
- * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
- * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
- * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
- * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
- * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
- * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
- * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- * ====================================================================
+/**
+ * $Revision: $
+ * $Date: $
  *
- * This software consists of voluntary contributions made by many
- * individuals on behalf of the Apache Software Foundation.  For more
- * information on the Apache Software Foundation, please see
- * <http://www.apache.org/>.
+ * Copyright (C) 2009 Jive Software. All rights reserved.
  *
- * Portions of this software are based upon public domain software
- * originally written at the National Center for Supercomputing Applications,
- * University of Illinois, Urbana-Champaign.
+ * This software is published under the terms of the GNU Lesser Public License (LGPL),
+ * a copy of which is included in this distribution.
  */
-
 package net.java.sipmack.sip.security;
 
 /**
@@ -66,8 +17,9 @@
  * @version 1.0
  */
 public class SipSecurityException extends Exception {
+	private static final long serialVersionUID = 3158525577631441256L;
 
-    public SipSecurityException() {
+	public SipSecurityException() {
 
         this("SipSecurityException");
     }
Index: src/plugins/sip/src/java/net/java/sipmack/media/VideoReceiver.java
===================================================================
--- src/plugins/sip/src/java/net/java/sipmack/media/VideoReceiver.java	(revision 0)
+++ src/plugins/sip/src/java/net/java/sipmack/media/VideoReceiver.java	(revision 0)
@@ -0,0 +1,181 @@
+/**
+ * $Revision: $
+ * $Date: $
+ *
+ * Copyright (C) 2009 Jive Software. All rights reserved.
+ *
+ * This software is published under the terms of the GNU Lesser Public License (LGPL),
+ * a copy of which is included in this distribution.
+ */
+
+package net.java.sipmack.media;
+
+import java.awt.Color;
+import java.awt.Component;
+
+import javax.media.ControllerErrorEvent;
+import javax.media.ControllerEvent;
+import javax.media.ControllerListener;
+import javax.media.Player;
+import javax.media.RealizeCompleteEvent;
+import javax.media.protocol.DataSource;
+import javax.media.rtp.Participant;
+import javax.media.rtp.RTPControl;
+import javax.media.rtp.ReceiveStream;
+import javax.media.rtp.ReceiveStreamListener;
+import javax.media.rtp.SessionListener;
+import javax.media.rtp.event.ByeEvent;
+import javax.media.rtp.event.NewParticipantEvent;
+import javax.media.rtp.event.NewReceiveStreamEvent;
+import javax.media.rtp.event.ReceiveStreamEvent;
+import javax.media.rtp.event.RemotePayloadChangeEvent;
+import javax.media.rtp.event.SessionEvent;
+import javax.media.rtp.event.StreamMappedEvent;
+import javax.swing.JFrame;
+import javax.swing.JPanel;
+
+/**
+ * This class implements receive methods and listeners to be used in VideoChannel
+ *
+ * @author Thiago Camargo 
+ */
+public class VideoReceiver implements ReceiveStreamListener, SessionListener,
+        ControllerListener {
+
+    boolean dataReceived = false;
+
+    Object dataSync;
+
+    public VideoReceiver(Object dataSync) {
+        this.dataSync = dataSync;
+    }
+
+    /**
+     * JingleSessionListener.
+     */
+    public synchronized void update(SessionEvent evt) {
+        if (evt instanceof NewParticipantEvent) {
+            Participant p = ((NewParticipantEvent) evt).getParticipant();
+            System.err.println("  - A new participant had just joined: " + p.getCNAME());
+        }
+    }
+
+    /**
+     * ReceiveStreamListener
+     */
+    public synchronized void update(ReceiveStreamEvent evt) {
+
+        Participant participant = evt.getParticipant();    // could be null.
+        ReceiveStream stream = evt.getReceiveStream();  // could be null.
+        
+        if (evt instanceof RemotePayloadChangeEvent) {
+
+            System.err.println("  - Received an RTP PayloadChangeEvent.");
+            System.err.println("Sorry, cannot handle payload change.");
+            // System.exit(0);
+
+        } else if (evt instanceof NewReceiveStreamEvent) {
+
+            try {
+                stream = ((NewReceiveStreamEvent) evt).getReceiveStream();
+                DataSource ds = stream.getDataSource();
+
+                System.out.println("DataSource:" + ds);
+                
+                // Find out the formats.
+                RTPControl ctl = (RTPControl) ds.getControl("javax.jmf.rtp.RTPControl");
+                if (ctl != null) {
+                    System.err.println("  - Recevied new RTP stream: " + ctl.getFormat());
+                } else
+                    System.err.println("  - Recevied new RTP stream");
+
+                if (participant == null)
+                    System.err.println("      The sender of this stream had yet to be identified.");
+                else {
+                    System.err.println("      The stream comes from: " + participant.getCNAME());
+                }
+
+                // create a player by passing datasource to the Media Manager
+                Player p = javax.media.Manager.createPlayer(ds);
+                if (p == null)
+                    return;
+                
+                p.addControllerListener(this);
+                p.realize();	
+  
+                // Notify intialize() that a new stream had arrived.
+                synchronized (dataSync) {
+                    dataReceived = true;
+                    dataSync.notifyAll();
+                }
+
+                
+                
+                System.out.println("Start2");
+                
+            } catch (Exception e) {
+                System.err.println("NewReceiveStreamEvent exception " + e.getMessage());
+                return;
+            }
+
+        } else if (evt instanceof StreamMappedEvent) {
+
+            if (stream != null && stream.getDataSource() != null) {
+                DataSource ds = stream.getDataSource();
+                // Find out the formats.
+                RTPControl ctl = (RTPControl) ds.getControl("javax.jmf.rtp.RTPControl");
+                System.err.println("  - The previously unidentified stream ");
+                if (ctl != null)
+                    System.err.println("      " + ctl.getFormat());
+                System.err.println("      had now been identified as sent by: " + participant.getCNAME());
+            }
+        } else if (evt instanceof ByeEvent) {
+
+            System.err.println("  - Got \"bye\" from: " + participant.getCNAME());
+
+        }
+
+    }
+
+    /**
+     * ControllerListener for the Players.
+     */
+    public synchronized void controllerUpdate(ControllerEvent ce) {
+
+        Player p = (Player) ce.getSourceController();
+
+        if (p == null)
+            return;
+
+        // Get this when the internal players are realized.
+        if (ce instanceof RealizeCompleteEvent) {
+            p.start();
+            
+            Component vc = p.getVisualComponent();
+            System.out.println("Start1.1" + vc);
+            if ( null != vc )
+            {
+                System.out.println("### visual component is " + vc);
+
+                JFrame aFrame = new JFrame("Video Frame");
+                JPanel aPanel = new JPanel();
+                aPanel.setBounds(0, 0, 176, 144);
+                aPanel.add(vc);
+                aFrame.add(aPanel);
+
+                aPanel.setBackground(Color.gray);
+
+                vc.setVisible(true);
+                aPanel.setVisible(true);
+                aFrame.setVisible(true);
+                aFrame.pack();
+            }
+        }
+
+        if (ce instanceof ControllerErrorEvent) {
+            p.removeControllerListener(this);
+            System.err.println("Receiver internal error: " + ce);
+        }
+
+    }
+}
Index: src/plugins/sip/src/java/net/java/sipmack/sip/CallProcessing.java
===================================================================
--- src/plugins/sip/src/java/net/java/sipmack/sip/CallProcessing.java	(revision 11009)
+++ src/plugins/sip/src/java/net/java/sipmack/sip/CallProcessing.java	(working copy)
@@ -1,68 +1,18 @@
-/* ====================================================================
- * The Apache Software License, Version 1.1
- *
- * Copyright (c) 2000 The Apache Software Foundation.  All rights
- * reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- *
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in
- *    the documentation and/or other materials provided with the
- *    distribution.
- *
- * 3. The end-user documentation included with the redistribution,
- *    if any, must include the following acknowledgment:
- *       "This product includes software developed by the
- *        Apache Software Foundation (http://www.apache.org/)."
- *    Alternately, this acknowledgment may appear in the software itself,
- *    if and wherever such third-party acknowledgments normally appear.
- *
- * 4. The names "Apache" and "Apache Software Foundation" must
- *    not be used to endorse or promote products derived from this
- *    software without prior written permission. For written
- *    permission, please contact apache@apache.org.
- *
- * 5. Products derived from this software may not be called "Apache",
- *    nor may "Apache" appear in their name, without prior written
- *    permission of the Apache Software Foundation.
- *
- * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
- * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
- * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
- * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
- * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
- * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
- * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
- * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
- * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- * ====================================================================
+/**
+ * $Revision: $
+ * $Date: $
  *
- * This software consists of voluntary contributions made by many
- * individuals on behalf of the Apache Software Foundation.  For more
- * information on the Apache Software Foundation, please see
- * <http://www.apache.org/>.
+ * Copyright (C) 2009 Jive Software. All rights reserved.
  *
- * Portions of this software are based upon public domain software
- * originally written at the National Center for Supercomputing Applications,
- * University of Illinois, Urbana-Champaign.
+ * This software is published under the terms of the GNU Lesser Public License (LGPL),
+ * a copy of which is included in this distribution.
  */
-
 package net.java.sipmack.sip;
 
 import gov.nist.javax.sip.header.CSeq;
-import gov.nist.javax.sip.header.Via;
-import gov.nist.javax.sip.message.SIPRequest;
-import net.java.sipmack.common.Log;
-import net.java.sipmack.sip.security.SipSecurityException;
+
+import java.text.ParseException;
+import java.util.ArrayList;
 
 import javax.sip.ClientTransaction;
 import javax.sip.Dialog;
@@ -74,12 +24,21 @@
 import javax.sip.address.Address;
 import javax.sip.address.SipURI;
 import javax.sip.address.URI;
-import javax.sip.header.*;
+import javax.sip.header.AllowHeader;
+import javax.sip.header.CSeqHeader;
+import javax.sip.header.CallIdHeader;
+import javax.sip.header.ContactHeader;
+import javax.sip.header.ContentLengthHeader;
+import javax.sip.header.ContentTypeHeader;
+import javax.sip.header.FromHeader;
+import javax.sip.header.MaxForwardsHeader;
+import javax.sip.header.ToHeader;
+import javax.sip.header.ViaHeader;
 import javax.sip.message.Request;
 import javax.sip.message.Response;
 
-import java.text.ParseException;
-import java.util.ArrayList;
+import net.java.sipmack.common.Log;
+import net.java.sipmack.sip.security.SipSecurityException;
 
 import org.jivesoftware.spark.phone.PhoneManager;
 
@@ -278,8 +237,6 @@
     void processAuthenticationChallenge(ClientTransaction clientTransaction,
                                         Response response) {
         try {
-            Request challengedRequest = clientTransaction.getRequest();
-
             ClientTransaction retryTran = sipManCallback.sipSecurityManager
                     .handleChallenge(response, clientTransaction);
             // There is a new dialog that will be started with this request. Get
